## ros-noetic-qb-chain-controllers 2.2.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2 FATAL_ERROR)
project(qb_chain_controllers VERSION 2.2.3 LANGUAGES CXX)

# Dependency Settings
find_package(catkin REQUIRED
  COMPONENTS
    roscpp
    control_msgs
    controller_interface
    geometry_msgs
    interactive_markers
    sensor_msgs
    trac_ik_lib
    tf2
    tf2_geometry_msgs
    tf2_ros
    qb_chain_msgs
)

include_directories(include
  ${catkin_INCLUDE_DIRS}
)

catkin_package(
  INCLUDE_DIRS
    include
  LIBRARIES
    ${PROJECT_NAME}
  CATKIN_DEPENDS
    roscpp
    trac_ik_lib
    control_msgs
    controller_interface
    geometry_msgs
    interactive_markers
    sensor_msgs
    tf2
    tf2_geometry_msgs
    tf2_ros
    qb_chain_msgs
)

# Exported libraries
add_library(${PROJECT_NAME}
  src/qb_kinematic_controller.cpp
  src/delta_kinematic_controller.cpp
  src/arm1_kinematic_controller.cpp
  src/arm2_kinematic_controller.cpp
  src/arm_v1_kinematic_controller.cpp
  src/arm_v2_kinematic_controller.cpp
  src/wrist_kinematic_controller.cpp
)

target_link_libraries(${PROJECT_NAME}
  PUBLIC
    ${catkin_LIBRARIES}
)

add_dependencies(${PROJECT_NAME}
  ${${PROJECT_NAME}_EXPORTED_TARGETS}
  ${catkin_EXPORTED_TARGETS}
)

# C++ Settings
if (CMAKE_VERSION VERSION_LESS "3.1")
  target_compile_options(${PROJECT_NAME}
    PUBLIC
      "-std=c++14"
  )
else ()
  set_property(
    TARGET
      ${PROJECT_NAME}
    PROPERTY CXX_STANDARD 14
  )

  set_property(
    TARGET
      ${PROJECT_NAME}
    PROPERTY CXX_STANDARD_REQUIRED ON
  )
endif ()

# Installation
install(
  TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION}
)

install(
  DIRECTORY
    include/${PROJECT_NAME}/
  DESTINATION
    ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

install(
  FILES
    plugin_arm1.xml
    plugin_arm2.xml
    plugin_arm_v1.xml
    plugin_arm_v2.xml
    plugin_delta.xml
    plugin_wrist.xml
  DESTINATION
    ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

=== debian/changelog ===
ros-noetic-qb-chain-controllers (2.2.3-1focal) focal; urgency=high



 -- Alessandro Tondo <alessandro.tondo@qbrobotics.com>  Thu, 04 Nov 2021 23:00:00 -0000

ros-noetic-qb-chain-controllers (2.2.2-1focal) focal; urgency=high



 -- Alessandro Tondo <alessandro.tondo@qbrobotics.com>  Sun, 29 Aug 2021 22:00:00 -0000

ros-noetic-qb-chain-controllers (2.2.1-1focal) focal; urgency=high



 -- Alessandro Tondo <alessandro.tondo@qbrobotics.com>  Thu, 26 Aug 2021 22:00:00 -0000

ros-noetic-qb-chain-controllers (2.2.0-1focal) focal; urgency=high

  * Fixed joint limits and default robot movement.
  * Minor changes
  * QBADV-56 Added a topic to notify the motion request
  * Fixed an error that prevents the usage of WAYPOINT modality. Added .yaml file for parsing wayoints.
  * Update license
  * Fix plugin manifests installation
  * Removed some anusefull comments
  * Fixed some errors in wrist kinematic and added the last kinematic config(arm_v2).
  * Wrist Kinematic implemented.
  * Added wrist files to implement the corresponding kinematic (not implemented yet).
  * Changed the names of the calsses according to robot configurations described in the guide (qbmove KIT 23/12/2020). for 'arm2' used the library 'trac_ik' for solving inverse kinematic problem.
  * fixed some minor bugs
  * Ignored the files used by VisualStudio Code.
  * Added the scripts for 2-axes wrist implementation. The project compiles but the inverse kinematic equations are wrong.
  * Added a third kinematic configuration. The open chain kinematics are named arm1 and arm 2.
  * added kinematic controller for arm1 configuration
  * Added arm3 kinematic controller and custom message to set velocity and stiffness togheter with end-effector position
  * Base class (KitKinematicController) is now less specific. Removed also some hardcoded parts.
  * First steps towards class separation. Functioning at this stage but no virtual functions implemented.
  * Changed class name (DeltaKinematicController -> KitKinematicController).
  * End-effector offset imposed only for wp. In other cases the offset is zero.

 -- Alessandro Tondo <alessandro.tondo@qbrobotics.com>  Wed, 25 Aug 2021 22:00:00 -0000

ros-noetic-qb-chain-controllers (2.1.1-1focal) focal; urgency=high

  * Fix dependencies

 -- Alessandro Tondo <alessandro.tondo@qbrobotics.com>  Mon, 10 Jun 2019 22:00:00 -0000

ros-noetic-qb-chain-controllers (2.1.0-1focal) focal; urgency=high

  * Add delta controller

 -- Alessandro Tondo <alessandro.tondo@qbrobotics.com>  Mon, 27 May 2019 22:00:00 -0000

=== debian/control ===
Source: ros-noetic-qb-chain-controllers
Section: misc
Priority: optional
Maintainer: Alessandro Tondo <alessandro.tondo@qbrobotics.com>
Build-Depends: debhelper (>= 9.0.0), ros-noetic-catkin, ros-noetic-control-msgs, ros-noetic-controller-interface, ros-noetic-geometry-msgs, ros-noetic-interactive-markers, ros-noetic-qb-chain-msgs, ros-noetic-roscpp, ros-noetic-sensor-msgs, ros-noetic-tf2, ros-noetic-tf2-geometry-msgs, ros-noetic-tf2-ros, ros-noetic-trac-ik-lib
Homepage: http://wiki.ros.org/qb_chain_controllers
Standards-Version: 3.9.2

Package: ros-noetic-qb-chain-controllers
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-noetic-control-msgs, ros-noetic-controller-interface, ros-noetic-geometry-msgs, ros-noetic-interactive-markers, ros-noetic-qb-chain-msgs, ros-noetic-roscpp, ros-noetic-sensor-msgs, ros-noetic-tf2, ros-noetic-tf2-geometry-msgs, ros-noetic-tf2-ros, ros-noetic-trac-ik-lib
Description: This package contains the specific controllers for qbrobotics® kinematic structures, e.g.
 the qbdelta controller.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-qb-chain-controllers//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
